<?php
set_time_limit(0);

function connect($recursion_count = 0) {
 $recursion_count++;
 
 $url = (isset($_SERVER['HTTP_X_URL']) ? trim($_SERVER['HTTP_X_URL']) : '');
 $url_parse = parse_url($url);
 $url_path = str_replace(array($url_parse['scheme'].'://'.$url_parse['host']), '', $url);
 $url_path = (($url_path) ? $url_path : '/');
 $headers = (isset($_SERVER['HTTP_X_HEADERS']) ? json_decode($_SERVER['HTTP_X_HEADERS'], true) : array());
 $headers_result = array();
 $other_data = (isset($_SERVER['HTTP_X_OTHER_DATA']) ? trim($_SERVER['HTTP_X_OTHER_DATA']) : '');
 $session_id = (isset($_SERVER['HTTP_X_SESSION_ID']) ? trim($_SERVER['HTTP_X_SESSION_ID']) : '');
 $quick_login = (isset($_SERVER['HTTP_X_QUICK_LOGIN']) ? (int) $_SERVER['HTTP_X_QUICK_LOGIN'] : 0);
 $quick_login_file_hash = (isset($_SERVER['HTTP_X_QUICK_LOGIN_FILE_HASH']) ? $_SERVER['HTTP_X_QUICK_LOGIN_FILE_HASH'] : '');
 $rewrite_cookies = (isset($_SERVER['HTTP_X_REWRITE_COOKIES']) ? (int) $_SERVER['HTTP_X_REWRITE_COOKIES'] : '');
 $tor_scheme_id = (isset($_SERVER['HTTP_X_TOR_SCHEME_ID']) ? (int) $_SERVER['HTTP_X_TOR_SCHEME_ID'] : 0);
 $port = (isset($_SERVER['HTTP_X_TOR_PORT']) ? (int) $_SERVER['HTTP_X_TOR_PORT'] : '9052');
 $port = '9050';

 if(!$url || !$session_id) {
  exit;
 }

 $cookies_file_path = dirname(__FILE__).'/tmpcookies/'.$session_id.'.txt';
 $cookies_quick_file_path = dirname(__FILE__).'/tmpcookies_quick/'.$quick_login_file_hash.'.txt';
 $cookies_file_content = file_get_contents($cookies_file_path);

 if($quick_login) {
  $cookies_file_path_result = $cookies_quick_file_path;
 } else {
  $cookies_file_path_result = $cookies_file_path;
 }

 $content_type = '';

 if(preg_match('/multipart\/form\-data/', $headers['Content-Type'])) {
  $content_type = 'multipart/form-data';

  $headers['Content-Type'] = 'multipart/form-data';
 }

 if(!isset($headers['User-Agent'])) {
  $headers['User-Agent'] = 'Mozilla/5.0 (Windows NT 10.0; rv:78.0) Gecko/20100101 Firefox/78.0';
 }

 foreach($headers as $name => $value) {
  $headers_result[] = $name.': '.$value;
 }

 if(($ch = curl_init()) != true) {
  die('No cure init');
 }

 curl_setopt($ch, CURLOPT_URL, $url);
 curl_setopt($ch, CURLOPT_HEADER, 1);
 curl_setopt($ch, CURLINFO_HEADER_OUT, 1);
 curl_setopt($ch, CURLOPT_HTTPPROXYTUNNEL, 1);
 curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
 curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
 curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
 curl_setopt($ch, CURLOPT_TIMEOUT, 40);
 curl_setopt($ch, CURLOPT_ENCODING, 'gzip,deflate');

 if($quick_login && !file_exists($cookies_quick_file_path)) {
  curl_setopt($ch, CURLOPT_COOKIE, $_SERVER['HTTP_X_COOKIES']);

  file_put_contents($cookies_quick_file_path, cookiesToNetscape($url_parse['host'], $_SERVER['HTTP_X_COOKIES']));
 } else {
  curl_setopt($ch, CURLOPT_COOKIEFILE, $cookies_file_path_result);
  curl_setopt($ch, CURLOPT_COOKIEJAR, $cookies_file_path_result);
 }

 if($rewrite_cookies) {
  file_put_contents($cookies_file_path, cookiesToNetscape($url_parse['host'], $_SERVER['HTTP_X_COOKIES']));
 }

 if(isset($_POST) && count($_POST) > 0) {
  if($content_type == 'multipart/form-data') {
   $data = buildPostFields($_POST);
  } else {
   $data = http_build_query($_POST);
  }

  curl_setopt($ch, CURLOPT_POST, 1);

  if($other_data) {
   curl_setopt($ch, CURLOPT_POSTFIELDS, $other_data);
  } else {
   curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
  }
 } else {
  if($other_data) {
   curl_setopt($ch, CURLOPT_POSTFIELDS, $other_data);
  }
 }

 if(count($headers_result) > 0) {
  curl_setopt($ch, CURLOPT_HTTPHEADER, $headers_result);
 }

 curl_setopt($ch, CURLOPT_PROXY, '127.0.0.1:'.$port);
 curl_setopt($ch, CURLOPT_PROXYTYPE, CURLPROXY_SOCKS5_HOSTNAME);
 curl_setopt($ch, CURLOPT_PROXYUSERPWD, 'shid:'.$tor_scheme_id);
 curl_setopt($ch, CURLOPT_PROXYAUTH, CURLAUTH_ANY);

 $response = curl_exec($ch);

 $curl_info = curl_getinfo($ch);

 $curl_error = curl_error($ch);

 $headers_size = curl_getinfo($ch, CURLINFO_HEADER_SIZE);
 $headers = substr($response, 0, $headers_size);
 $sent_headers = curl_getinfo($ch, CURLINFO_HEADER_OUT);
 $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
 $content = substr($response, $headers_size);

 curl_close($ch);

 preg_match_all('|Set-Cookie: (.*);|U', $headers, $parse_cookies);

 if(isset($parse_cookies[1]) && !$parse_cookies[1]) {
  preg_match_all('|Set-Cookie: (.*?)|U', $headers, $parse_cookies);
 }

 $cookies = implode(';', $parse_cookies[1]);

 preg_match_all('/^Location:(.*)$/mi', $headers, $location);

 if(!empty($location[1][0])) {
  $location = trim($location[1][0]);
  $location_parse = parse_url($location);

  $location = str_replace(array($location_parse['scheme'].'://'.$location_parse['host']), '', $location);
  $location = (($location) ? $location : '/');
 } else {
  $location = '';
 }

 if($location == $url_path) {
  $location = '';
 }

 if(preg_match('/(Content\-Type\: image|Content\-type\: image|content\-type\: image)/isu', $headers)) {
  $content = urlencode($content);
 }

 $curl_info['recursion_count'] = $recursion_count;

 $data = array(
  'headers' => $headers,
  'sent_headers' => $sent_headers,
  'http_code' => $http_code,
  'cookies' => $cookies,
  'curl_error' => $curl_error,
  'curl_info' => $curl_info,
  'url' => $url,
  'port' => $port,
  'content' => $content,
  'cookies_file_content' => $cookies_file_content,
  'tor_scheme_id' => $tor_scheme_id
 );

 if($location) {
  $data['location'] = trim($location);
 }

 $result = $data;

 if($recursion_count >= 3) {

 } elseif($http_code == 0) {
  $result = connect($recursion_count);
 }

 return $result;
}

echo json_encode(connect());

function buildPostFields($data, $existingKeys = '', &$return_array = array()) {
 if(($data instanceof CURLFile) or !(is_array($data) or is_object($data))) {
  $return_array[$existingKeys] = $data;
 } else {
  foreach($data as $key => $item) {
   buildPostFields($item, $existingKeys ? $existingKeys."[$key]" : $key, $return_array);
  }
 }

 return $return_array;
}

function cookiesToNetscape($host = null, $cookies = null) {
 $result = '# Netscape HTTP Cookie File
# http://curl.haxx.se/docs/http-cookies.html
# This file was generated by libcurl! Edit at your own risk.';

 $cookies_explode = explode(';', $cookies);

 $cookies_result = array();

 for($i = 0; $i < count($cookies_explode); $i++) {
  preg_match('/^(.*?)\=(.*)/', $cookies_explode[$i], $matches);

  if(trim($matches[1])) {
   $cookies_result[] = $host."\tFALSE\t/\tFALSE\t0\t".trim($matches[1])."\t".trim($matches[2]);
  }
 }

 $result .= "\n\n";
 $result .= implode("\n", $cookies_result);

 return $result;
}
?>
